
!Behavior methodsFor: '*ContextS2PostLoad' stamp: 'mpe 8/10/2010 22:56'!
basicAddSelector: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the 
	receiver's method dictionary.
	Do this without sending system change notifications"

	| oldMethodOrNil method |
	oldMethodOrNil := self lookupSelector: selector.
	method := self contextSConversionOld: (self compiledMethodAt: selector ifAbsent: [nil]) new: compiledMethod.
	self methodDict at: selector put: method.
	method methodClass: self.
	method selector: selector.

	"Now flush Squeak's method cache, either by selector or by method"
	oldMethodOrNil == nil ifFalse: [oldMethodOrNil flushCache].
	selector flushCache.! !

!Behavior methodsFor: '*ContextS2PostLoad' stamp: 'mpe 8/6/2010 17:15'!
contextSConversionOld: oldMethodOrNil new: aNewMethod
	((aNewMethod class == CompiledMethod) and: [oldMethodOrNil class == CSLayeredMethod])
		ifTrue: [	oldMethodOrNil addBaseMethod: aNewMethod.
				^ oldMethodOrNil].
	aNewMethod class == CSPartialMethod
		ifTrue: [	oldMethodOrNil ifNil: [^ CSLayeredMethod on: {aNewMethod}].
				oldMethodOrNil class == CompiledMethod
					ifTrue: [^ CSLayeredMethod on: {aNewMethod. oldMethodOrNil asPartialMethod}].
				oldMethodOrNil class == CSLayeredMethod
					ifTrue: [	oldMethodOrNil addPartialMethod: aNewMethod.
							^ oldMethodOrNil]].
	"previous nil and compiled method entries are standard behavior"
	^ aNewMethod! !
